const $ = require('jquery');
require("../css/itemManager.less");
require('./../resource/jquery-ui/jquery-ui.min.js');
require('./modal.js');
const { api } = require('./api.js')
const { post, getCookie, emptyBox, initScroll, expJson, downloadExportedData } = require('./utils.js')
const switchIconOpen = require("./../images/btn_open.png")
const switchIconClose = require("./../images/btn_close.png")
const iconDown = require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const arrowLeft = require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")


let casesId = "", name = "", isReject = "", isUsed = "", casesIdTemp = "", nameTemp = "", isRejectTemp = "", isUsedTemp = "", size = 15
let totalNum = 0
$(".selectModuleType").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectReject").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectUsed").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".abnormalClear").click(function () {
    window.location.reload()
})

//YH-JCSJWH-TMSJWH
$(".menu .page", parent.document).removeClass("active");
$(parent.document).find(".menu .page[code=YH-JCSJWH-TMSJWH]").addClass("active")

//判断有无某一权限
function hasData(data) {
    let lis = JSON.parse(getCookie("codeLis")) || []
    if (lis.indexOf(data) > -1) {//有权限
        return true
    }
    return false;
}
//获取表格数据
function getTabData(activePage) {
    const param = {
        current: activePage,
        casesId: $(".filterItem .document-type").attr("value"),
        name: name, //条目名
        isReject: isReject, //1-单项否决 0-非
        isUsed: $(".filterItem .rule-status").attr("value"), //0-未启用 1-启用
        size: size,
        remark: $(".filterItem .moduleItemInp").val(),
        syRuleType: +$(".filterItem .rule-type").attr("value"),
        remindType: +$(".filterItem .remind-type").attr("value"),
        remindLevel: +$(".filterItem .remind-level").attr("value")
    }
    $('.pagination').empty()
    $('.tbody').html(emptyBox('努力加载中...', '', 1))
    post(api.getQcCasesEntryAll, param).then(res => {
        console.log("getQcCasesEntryAll", res.data)
        // return
        if (res.data.code == '0') {
            const data = res.data.data.records
            const totalPage = res.data.data.pages
            totalNum = res.data.data.total
            renderTab(data, activePage)
            if (totalPage > 1) {
                renderPagination(totalPage, Number(activePage), totalNum)
            } else {
                $('.pagination').empty()
            }

        } else {
            $('.tbody').html(emptyBox())
        }
    }).catch((e) => {

    })
}
$(".moduleItemInp").on("input", function (e) {
    const val = $(this).val().trim()
    nameTemp = val
})
$(".filter").on("click", function (e) {
    casesId = casesIdTemp, name = nameTemp, isReject = isRejectTemp, isUsed = isUsedTemp
    getTabData(1)
})
$('.selectModuleType').on("click", function (e) {
    e.stopPropagation()
    $(".rejectList ").css("display", "none")
    $(".usedList ").css("display", "none")
    $(".selectReject .arrow").attr("src", iconDown)
    $(".selectUsed .arrow").attr("src", iconDown)
    const showList = $(".moduleTypeList ").css("display")
    if (showList == "none" || !showList) {
        $(".moduleTypeList ").css("display", "block")
        $(".selectModuleType .arrow").attr("src", iconUp)
    } else {
        $(".moduleTypeList ").css("display", "none")
        $(".selectModuleType .arrow").attr("src", iconDown)
    }
})

$('.selectReject').on("click", function (e) {
    e.stopPropagation()
    $(".moduleTypeList ").css("display", "none")
    $(".usedList ").css("display", "none")
    $(".selectModuleType .arrow").attr("src", iconDown)
    $(".selectUsed .arrow").attr("src", iconDown)
    const showList = $(".rejectList ").css("display")
    if (showList == "none" || !showList) {
        $(".rejectList ").css("display", "block")
        $(".selectUsed .arrow").attr("src", iconUp)
    } else {
        $(".rejectList ").css("display", "none")
        $(".selectUsed .arrow").attr("src", iconDown)
    }
})
$('.selectUsed').on("click", function (e) {
    e.stopPropagation()
    $(".moduleTypeList ").css("display", "none")
    $(".rejectList ").css("display", "none")
    $(".selectModuleType .arrow").attr("src", iconDown)
    $(".selectReject .arrow").attr("src", iconDown)
    const showList = $(".usedList ").css("display")
    if (showList == "none" || !showList) {
        $(".usedList ").css("display", "block")
        $(".selectUsed .arrow").attr("src", iconUp)
    } else {
        $(".usedList ").css("display", "none")
        $(".selectUsed .arrow").attr("src", iconDown)
    }
})
bindRejectSelect()
bindUsedSelect()
getTabData(1)
getmoduleTypeList()
function renderTab(data, activePage) {
    if (data.length === 0) {
        $('.tbody').html(emptyBox())
        return
    }
    let str = ``;
    const cls = hasData("FUNC000007") ? "editItem" : "editItemDis";
    for (let i = 0; i < data.length; i++) {
        const item = data[i]
        str += `
            <tr data-id=${item.id} data-index=${i}>
                <td  class="textCenter" width="50">${(activePage - 1) * size + i + 1}</td>
                <td>${item.name}</td>
                <td>${item.remark || ""}</td>
                <td>${item.syRuleType === 0 ? '主诊断错误' : '其它诊断遗漏'}</td>
                <td  class="textCenter">${item.casesName}</td>
                <td  class="textCenter">${item.remindType == '0' ? `全部提醒` : `仅病案室提醒`}</td>
                <td style="text-align:center;"> ${item.remindLevel}</td>
                <td class="textCenter">${item.isUsed == 1 ? `生效` : `不生效`}</td>
                <td class="editItem textCenter" style="opacity:${hasData('FUNC000007') ? '1' : '0.5'}">修改</td>
            </tr>
        `
    }
    $('.tbody').html(str)
    bindEdit(data, activePage)
    // initScroll("managerContainer","Y",1)
}

function bindEdit(data, activePage) {
    if (!hasData('FUNC000007')) {
        return
    }
    $('.editItem').click(function (e) {
        const index = $(this).parent().attr('data-index')
        editItem(data[index], activePage)
    })
}

//修改
function editItem(item, activePage) {

    const itemCopy = JSON.parse(JSON.stringify(item))
    // console.log("editItem", item, itemCopy)
    $('.pop-box').remove()
    $('.container').append('<div class="pop-box"></div>')
    const str = `
        <div class="itemMsgBox">
            <div class="mask"></div>
            <div class="itemMsgContent">
                <p class="itemMsgTitle">修改 <img class="iconClose" src=${require('./../images/icon_close_default.png')} alt="关闭" /></p>
                <div class="itemMsgContentBox ">
                    <div class="itemMsgInfoBox new-box"><span>规则名称：</span> <textarea class="rule-name" ></textarea></div>
                    <div class="itemMsgInfoBox new-box"><span>规则业务逻辑：</span> <textarea class="rule-logic" ></textarea></div>
                    <div class="itemMsgInfoBox new-box">
                         <div>
                            <span class="filterItem typeFilter dropdown">
                                <span>规则类型：</span>
                                <span class="dropdown-text ellipsis rule-type" value="${itemCopy.syRuleType}">
                                    <i class="label">${itemCopy.syRuleType === 0 ? '主诊断错误' : '其它诊断遗漏'}</i>
                                </span>
                                <ul class="dropdownList">
                                    <li class="dropdownList-item" value="0">主诊断错误</li>
                                    <li class="dropdownList-item" value="1">其它诊断遗漏</li>
                                </ul>
                            </span>
                            <span class="filterItem typeFilter dropdown">
                                <span>规则提醒类型：</span>
                                <span class="dropdown-text ellipsis remind-type" value="${itemCopy.remindType}">
                                 <i class="label">${itemCopy.remindType === 0 ? '全部提醒' : '仅病案室提醒'}</i>
                                </span>
                                <ul class="dropdownList">
                                    <li class="dropdownList-item" value="0">全部提醒</li>
                                    <li class="dropdownList-item" value="1">仅病案室提醒</li>
                                </ul>
                            </span>
                         </div>
                         <div>
                            <span class="filterItem typeFilter dropdown">
                                <span>规则所属文书类型：</span>
                                <span class="dropdown-text ellipsis document-type" value="243"> <i class="label">病案首页</i></span>
                                <ul class="dropdownList">
                                    <li class="dropdownList-item" value="243">病案首页</li>
                                </ul>
                            </span>

                            <span class="filterItem typeFilter dropdown">
                                <span>规则提醒级别：</span>
                                <span class="dropdown-text ellipsis remind-level" value="${itemCopy.remindLevel}">
                                    <i class="label">${itemCopy.remindLevel === 1 ? '1(仅提示)' : itemCopy.remindLevel === 2 ? '2' : '3'}</i>
                                </span>
                                <ul class="dropdownList">
                                    <li class="dropdownList-item" value="1">1(仅提示)</li>
                                    <li class="dropdownList-item" value="2">2</li>
                                    <li class="dropdownList-item" value="3">3</li>
                                </ul>
                            </span>
                         </div>
                    </div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">单项否决：</span><span class="itemInfoRight itemReject">${item.isReject == '1' ? `<img class="switchImg" src=${switchIconOpen} /><span class="imgInfo">  是</span>` : `<img class="switchImg" src=${switchIconClose} /> <span class="imgInfo"> 否</span>`}</span></div>
                     <div class="itemMsgInfoBox"><span class="itemMsgLab">启用：</span><span class=" temInfoRight itemUsed">${item.isUsed == '1' ? `<img class="switchImg" src=${switchIconOpen} /><span class="imgInfo"> 是</span>` : `<img class="switchImg" src=${switchIconClose} /> <span class="imgInfo"> 否</span>`}</span></div>
                </div>
                <div class="confirmEditBox"><span class="confirmEdit">保存</span></div>
            </div>
        </div>
       
    `
    $("#mainBox", parent.document).append(str)
    // 防止存在特殊字符，导致原有数据不显示
    $("#mainBox .new-box .rule-name", parent.document).val(itemCopy.name)
    $("#mainBox .new-box .rule-logic", parent.document).val(itemCopy.remark)
    // $("#mainBox .new-box .rule-logic", parent.document).val(itemCopy.remark)

    $("#mainBox .itemMsgBox .iconClose", parent.document).on("click", function (e) {
        $("#mainBox .itemMsgBox", parent.document).remove()
    })
    $("#mainBox .itemMsgBox .itemTipMsg", parent.document).on("input", function (e) {
        const val = $(this).val().trim()
        itemCopy.msg = val
    })
    //接收输入数据
    $("#mainBox .itemMsgBox .rule-name", parent.document).on("input", function (e) {
        const val = $(this).val().trim()
        itemCopy.name = val
    })
    $("#mainBox .itemMsgBox .rule-logic", parent.document).on("input", function (e) {
        const val = $(this).val().trim()
        itemCopy.remark = val
    })

    $("#mainBox .itemMsgBox .itemScore", parent.document).on("keypress", function (e) {
        return (/[0-9\.]/.test(String.fromCharCode(e.keyCode)))
    })
    $("#mainBox .itemMsgBox .itemScore", parent.document).on("input", function (e) {
        const val = $(this).val()
        itemCopy.score = val
    })
    $("#mainBox .itemMsgBox .itemReject", parent.document).on("click", function (e) {
        itemCopy.isReject = itemCopy.isReject == 1 ? 0 : 1
        $('#mainBox .itemMsgBox', parent.document).remove()
        editItem(itemCopy, activePage)
    })
    $("#mainBox .itemMsgBox .itemUsed", parent.document).on("click", function (e) {
        itemCopy.isUsed = itemCopy.isUsed == 1 ? 0 : 1
        $('#mainBox .itemMsgBox', parent.document).remove()
        editItem(itemCopy, activePage)
    })

    $("#mainBox .itemMsgBox .confirmEdit", parent.document).on("click", function () {
        var reg = new RegExp(/^\d+(\.\d)?$/);
        if (reg.test(itemCopy.score) && itemCopy.score <= 100) {
            if (!itemCopy.msg.trim()) {
                $.alerModal({ "message": "提示信息不能为空~", type: "tip", time: '1000', isFather: true, fatherWrapper: $("#mainBox", parent.document) });
                return
            }
            itemCopy.casesId = $("#mainBox .filterItem .document-type", parent.document).attr("value")
            itemCopy.syRuleType = +$("#mainBox .filterItem .rule-type", parent.document).attr("value")
            itemCopy.remindType = +$("#mainBox .filterItem .remind-type", parent.document).attr("value")
            itemCopy.remindLevel = +$("#mainBox .filterItem .remind-level", parent.document).attr("value")
            saveEdit(itemCopy, activePage)
            $("#mainBox .itemMsgBox .itemMsgInfoTips", parent.document).css("display", "none")
            $('#mainBox .itemMsgBox', parent.document).remove()
            return
        } else {
            $("#mainBox .itemMsgBox .itemMsgInfoTips", parent.document).css("display", "block")

            return
        }

    })
    $("#mainBox .dropdown-text", parent.document).append(`<img class="arrow" src=${iconDown} alt="下拉">`)

    $("#mainBox .dropdown-text", parent.document).on("click", function (event) {
        event.stopPropagation()
        const that = this
        $("#mainBox .dropdownList", parent.document).not($(this).siblings(".dropdownList")).fadeOut(function () {
            // $(that).children(".arrow").attr("src", iconDown)
            $("#mainBox .dropdown-text .arrow", parent.document).not($(that).children(".arrow")).attr("src", iconDown)
        })
        // $(this).parent().find(".dropdownList").fadeIn()
        $(this).siblings(".dropdownList").fadeToggle(function () {
            const status = $(this).css("display")
            // console.log("status", status)
            if (status === "block") {
                $(that).children(".arrow").attr("src", iconUp)
            } else {
                $(that).children(".arrow").attr("src", iconDown)
            }
        })

    })

    $("#mainBox .dropdownList .dropdownList-item", parent.document).on("click", function (event) {
        event.stopPropagation()
        const value = $(this).attr("value")
        const label = $(this).text()
        $(this).parent().siblings(".dropdown-text").children(".label").text(label)
        $(this).parent().siblings(".dropdown-text").attr("value", value)
        $(this).parent().fadeOut(function () {
            $("#mainBox .dropdown-text .arrow", parent.document).attr("src", iconDown)
        })
    })
    $("html", parent.document).on("click", function () {
        $("#mainBox .dropdownList", parent.document).fadeOut(function () {
            // $(that).children(".arrow").attr("src", iconDown)
            $("#mainBox .dropdown-text .arrow", parent.document).attr("src", iconDown)
        })
    })


}

$(".download").on('click', function (e) {
    const params = {
        current: 1,
        casesId: $(".filterItem .document-type").attr("value"),
        name: name, //条目名
        isReject: isReject, //1-单项否决 0-非
        isUsed: $(".filterItem .rule-status").attr("value"), //0-未启用 1-启用
        size: totalNum || size,
        remark: $(".filterItem .moduleItemInp").val(),
        syRuleType: +$(".filterItem .rule-type").attr("value"),
        remindType: +$(".filterItem .remind-type").attr("value"),
        remindLevel: +$(".filterItem .remind-level").attr("value")
    }
    expJson(api.downloadQcCasesEntryAll, params).then(res => {
        downloadExportedData(res.data, "规则维护.xls")
    })
    // post(api.downloadQcCasesEntryAll, params).then((res) => {
    //     const { code, msg, data } = res.data
    //     console.log("res")
    //     if (code === '0') {

    //     } else {
    //         $.alerModal({ "message": msg, type: "tip", time: '1000', isFather: true, win: 'default', fatherWrapper: $("#mainBox", parent.document) });

    //     }

    // }).catch(err => {

    // })
})

//保存修改
function saveEdit(item, activePage) {
    const param = {
        id: item.id,
        isReject: item.isReject,
        isUsed: item.isUsed,
        msg: item.msg,
        name: item.name,
        score: item.score,
        remark: item.remark,
        syRuleType: item.syRuleType,
        remindType: item.remindType,
        remindLevel: item.remindLevel
    }

    post(api.updataQcCasesEntry, param).then(res => {
        if (res.data.code == '0') {
            // const data = res.data.data
            $.alerModal({ "message": "修改成功", type: "tip", time: '1000', isFather: true, win: true, fatherWrapper: $("#mainBox", parent.document) });
            getTabData(activePage)
        } else {
            $.alerModal({ "message": '修改失败,请重试~', type: "tip", time: '1000', isFather: true, win: 'default', fatherWrapper: $("#mainBox", parent.document) });

        }
    }).catch((e) => {
        $.alerModal({ "message": '修改失败,请重试~', type: "tip", time: '1000', isFather: true, win: 'default', fatherWrapper: $("#mainBox", parent.document) });

    })
}

//获取模块类型
function getmoduleTypeList() {
    post(api.getQcCasesAll).then(res => {
        if (res.data.code == '0') {
            const moduleTypeList = res.data.data
            renderModuleTypeList(moduleTypeList)
        } else { }
    }).catch((e) => {

    })
}


function renderModuleTypeList(moduleTypeList) {
    let str = `<li class="modeTypeItem " data-id=" " data-name="全部">全部</li>`
    for (let i = 0; i < moduleTypeList.length; i++) {
        str += `<li class="modeTypeItem ellipsis" title=${moduleTypeList[i].name} data-id=${moduleTypeList[i].id} data-name=${moduleTypeList[i].name}> ${moduleTypeList[i].name}</li>`
    }
    $('.moduleTypeList').html(str)
    bindModuleTypeSelect()
}

//模块类型选择
function bindModuleTypeSelect() {
    $('.modeTypeItem').on("click", function () {
        const modeTypeItemName = $(this).attr("data-name")
        const modeTypeItemId = $(this).attr("data-id")
        casesIdTemp = modeTypeItemId
        $('.selectModuleType').html(modeTypeItemName).attr("title", modeTypeItemName)
        $(".selectModuleType").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

        $(".moduleTypeList ").css("display", "none")
    })
}
function bindDropdown() {
    $(".dropdown-text").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

    $(".dropdown-text").on("click", function (event) {
        event.stopPropagation()
        const that = this
        $(".dropdownList").not($(this).siblings(".dropdownList")).fadeOut(function () {
            // $(that).children(".arrow").attr("src", iconDown)
            $(".dropdown-text .arrow").not($(that).children(".arrow")).attr("src", iconDown)
        })
        // $(this).parent().find(".dropdownList").fadeIn()
        $(this).siblings(".dropdownList").fadeToggle(function () {
            const status = $(this).css("display")
            // console.log("status", status)
            if (status === "block") {
                $(that).children(".arrow").attr("src", iconUp)
            } else {
                $(that).children(".arrow").attr("src", iconDown)
            }
        })

    })
    $(".dropdownList .dropdownList-item").on("click", function (event) {
        event.stopPropagation()
        const value = $(this).attr("value")
        const label = $(this).text()
        $(this).parent().siblings(".dropdown-text").children(".label").text(label)
        $(this).parent().siblings(".dropdown-text").attr("value", value)
        $(this).parent().fadeOut(function () {
            $(".dropdown-text .arrow").attr("src", iconDown)
        })
    })
    $("html").on("click", function () {
        $(".dropdownList").fadeOut(function () {
            // $(that).children(".arrow").attr("src", iconDown)
            $(".dropdown-text .arrow").attr("src", iconDown)
        })
    })
}
bindDropdown()

//单项否决选择
function bindRejectSelect() {
    $('.rejectItem').on("click", function () {
        const rejectItemName = $(this).attr("data-name")
        const rejectItemId = $(this).attr("data-id")
        isRejectTemp = rejectItemId
        $('.selectReject').html(rejectItemName)
        $(".rejectList ").css("display", "none")
        $(".selectReject").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

    })
}
//是否启用选择
function bindUsedSelect() {
    $('.usedItem').on("click", function () {
        const usedItemName = $(this).attr("data-name")
        const usedItemItemId = $(this).attr("data-id")
        isUsedTemp = usedItemItemId
        $('.selectUsed').html(usedItemName)
        $(".usedList").css("display", "none")
        $(".selectUsed").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    })
}




//分页渲染
function renderPagination(totalPage, activePage, totalNum) {
    let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
    if (totalPage <= 6) {
        for (let i = 1; i <= totalPage; i++) {
            str += `<span class="pageNum ${'page' + i}" data-page=${i}>${i}</span>`
        }
    } else {
        if (activePage <= 3) { //选中页数小于4
            for (let i = 1; i <= 4; i++) {
                str += `<span class="pageNum ${'page' + i}" data-page=${i}>${i}</span>`
            }
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page' + totalPage}" data-page=${totalPage}>${totalPage}</span>`

        } else if (activePage > totalPage - 3) {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page' + (totalPage - 3)}" data-page=${totalPage - 3}>${totalPage - 3}</span>`
            str += `<span class="pageNum ${'page' + (totalPage - 2)}" data-page=${totalPage - 2}>${totalPage - 2}</span>`
            str += `<span class="pageNum ${'page' + (totalPage - 1)}" data-page=${totalPage - 1}>${totalPage - 1}</span>`
            str += `<span class="pageNum ${'page' + totalPage}" data-page=${totalPage}>${totalPage}</span>`
        } else {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page' + (activePage - 1)}" data-page=${activePage - 1}>${activePage - 1}</span>`
            str += `<span class="pageNum ${'page' + activePage}" data-page=${activePage}>${activePage}</span>`
            str += `<span class="pageNum ${'page' + (activePage + 1)}" data-page=${activePage + 1}>${activePage + 1}</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page' + totalPage}" data-page=${totalPage}>${totalPage}</span>`
        }

    }
    str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
    $('.pagination').html(str)
    $('.page' + activePage).addClass('activePage')
    $(".pageNum").on("click", function (e) {
        const activePageNow = Number($(this).attr('data-page'))
        getTabData(activePageNow)
        // renderPagination(totalPage,activePageNow,totalNum)
    })
    $(".prePage").on("click", function (e) {
        let activePageNow = Number($(".activePage").attr('data-page'))
        if (activePageNow > 1) {
            activePageNow--
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    $(".nextPage").on("click", function (e) {
        let activePageNow = Number($(".activePage").attr('data-page'))
        if (activePageNow < totalPage) {
            activePageNow++
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })

}

$(document).on("click", function () {
    $(".moduleTypeList ").css("display", "none")
    $(".rejectList ").css("display", "none")
    $(".usedList ").css("display", "none")
    $(".selectModuleType .arrow").attr("src", iconDown)
    $(".selectReject .arrow").attr("src", iconDown)
    $(".selectUsed .arrow").attr("src", iconDown)
})